# -*- coding: utf-8 -*-

import re,sys,os
import codecs

#reseparator = re.compile(r'[ !\"#\$%&\'\(\)*+,./:;<=>?@\[\\\]\^_\`\{\|\}~\r\n\t]+')
reseparator = re.compile(r'[ !\"#\$%&\'\(\)*+,/:;<=>?\[\\\]\^_\`\{\|\}~\r\n\t]+')
herecache = {}

def genHere(headers):
    if headers in herecache:
        return herecache[headers]
    tre = re.compile("^(?:%s)[ \t]*:(?:.|\n[ \t])*(?:\n|$)" % ("|".join(headers)), re.I|re.M)
    herecache[headers] = tre
    return tre

def filterOutHeaders(s, headers):
    l = s.split("\n\n")
    here = genHere(headers)
    l[0] = "".join(here.findall(l[0]))
    return "\n\n".join(l)

class dist(object):
    def __init__(self, fn=None):
        if fn is not None:
            self.load(fn)
        else:
            self.cnt = 0
            self.d = {}

    def add(self, s, headers=None, multipleCount=False):
        if headers is not None:
            s = filterOutHeaders(s, headers)
        td = {}

        if multipleCount:
            for w in reseparator.split(s):
                self.addword(w)
        else:
            for w in reseparator.split(s):
                td[w] = 1
            for w in td:
                self.addword(w)

    def addfile(self, fn, headers=None, multipleCount=False):
        f = codecs.open(fn, "r", "utf-8")
        s = f.read()
        f.close()
        self.add(s, headers=headers, multipleCount=multipleCount)

    def adddir(self, dn, headers=None):
        for f in os.listdir(dn):
            fp = os.path.join(dn, f)
            if os.path.isfile(fp):
                self.addfile(fp, headers)

    def addword(self, w, cnt=1):
        if w == '':
            return
        if w in self.d:
            self.d[w] += cnt
        else:
            self.d[w] = cnt
        self.cnt += cnt
        
    def adddist(self, di):
        for w in di.d:
            self.addword(w, cnt=di.d[w])

    def __repr__(self):
        rv = []
        tuples = [(self.d[k],k) for k in self.d]
        tuples.sort()
        tuples.reverse()
        for n,w in tuples:
            rv.append("%5s %s" % (n, w))
        return "\n".join(rv)+"\n"

    def __contains__(self, x):
        return x in self.d

    def save(self, fn):
        w = codecs.open(fn, "w", "utf-8")
        w.write(self.tostr())
        w.close()

    def load(self, fn):
        self.d = {}
        cnt = 0
        for l in codecs.open(fn, "r", "utf-8"):
            i = 0
            while l[i] == ' ':
                i += 1
            try:
                spci = l.index(' ', i)
            except:
                continue
            c = int(l[i:spci])
            k = l[spci+1:-1]
            if k not in self.d:
                self.d[k] = c
                cnt += c
        self.cnt = cnt

    def tostr(self):
        return dist.__repr__(self)
