# -*- coding: utf-8 -*-

import email

import email.Header

import sys,os,re

import types

import codecs



DEFAULT_CHARSET = 'iso-8859-1'



reascii = re.compile("^[\x00-\x7f]*$")



def decodeHeader(header):

    if '=' not in header:

        if reascii.search(header):

            return header

        return dec(header, DEFAULT_CHARSET)

    try:

        tv2 = email.Header.decode_header(header)

    except email.Errors.HeaderParseError:  # パディングのミスなど

        return header

    rv = []

    for s, enc in tv2:

        if enc is not None:

            s = dec(s, enc)

        rv.append(s)

    return "".join(rv)



def dec(s, enc):

    try:

        decoder = codecs.getdecoder(enc)

    except LookupError:

        decoder = codecs.getdecoder(DEFAULT_CHARSET)

    return decoder(s, 'replace')[0]



def extractmail(m):

    return getHeaders(m) + "\n" + extractFirstTextChunk(m).replace("\r", "")



def getHeaders(m):

    return "\n".join(map(lambda x,y: x+": "+decodeHeader(y), m.keys(), m.values())) + "\n"



def isStr(s):

    return type(s) in (str, unicode)



def extractFirstTextChunk(m):

    tv = extractFirstTextChunk0(m)

    if tv is None:

        tv = ''

    return tv



def extractFirstTextChunk0(m):

    c = m.get_charset() or m.get_charsets()[0] or DEFAULT_CHARSET

    payloads = m.get_payload(decode=True)

    if payloads is None:

        payloads = m.get_payload(decode=False)

    if isStr(payloads):

        return dec(payloads, c)

    idx = -1

    for x in payloads:

        idx+=1

        if isStr(x):

            try:

                c = m.get_charsets()[idx]

            except:

                pass

            return dec(x, c)

        if type(x) == types.InstanceType and x.__class__ == email.Message.Message:

            tv = extractFirstTextChunk(x)

            if isStr(tv):

                return tv

    return None



def doit1(fp, tp):

    if os.path.exists(tp):

        print "Warning: %s exists, skipping" % tp

        return



    m = email.message_from_file(file(fp))

    t = codecs.open(tp, "w", encoding="utf-8")

    t.write(extractmail(m))

    t.close()



def main():

    fro = sys.argv[1]

    to = sys.argv[2]



    if os.path.isfile(fro):

        doit1(fro, to)

    elif os.path.isdir(fro):

        for f in os.listdir(fro):

            fp = fro + "/" + f

            if os.path.isfile(fp):

                tp = to + "/" + f

                doit1(fp, tp)



main()

